/*
 * Deskstation Tyne specific C parts
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1994, 1995 by Ralf Baechle
 */
/* This following cpp grossness is so that I can share this file with
   rpc44-c.c in the hopes that will help both files remain up to date */
#ifndef DS_TYPE
#define DS_TYPE deskstation_tyne_
#endif
#ifndef DS_MACHINE_TYPE
#define DS_MACHINE_TYPE MACH_DESKSTATION_TYNE
#endif
#ifndef DS_MACH_STR
#define DS_MACH_STR "Tyne"
#endif

#define MKNAME3(a,b) b##a
#define MKNAME2(a,b) MKNAME3(a,b)
#define MKNAME(a) MKNAME2(a,DS_TYPE)

#include <linux/delay.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <asm/bootinfo.h>
#include <asm/cachectl.h>
#include <asm/dma.h>
#include <asm/io.h>

/* KLUDGE TO GET IT TO COMPILE */
#define FLOPPY_DMA 0
#define FLOPPY_IRQ 5

/*
 * How to access the FDC's registers.
 */
unsigned char MKNAME(fd_inb)(unsigned int port)
{
	return inb_p(port);
}

void MKNAME(fd_outb)(unsigned char value, unsigned int port)
{
	outb_p(value, port);
}

/*
 * How to access the floppy DMA functions.
 */
void MKNAME(fd_enable_dma)(void)
{
	enable_dma(FLOPPY_DMA);
}

void MKNAME(fd_disable_dma)(void)
{
	disable_dma(FLOPPY_DMA);
}

int MKNAME(fd_request_dma)(void)
{
	return request_dma(FLOPPY_DMA, "floppy");
}

void MKNAME(fd_free_dma)(void)
{
	free_dma(FLOPPY_DMA);
}

void MKNAME(fd_clear_dma_ff)(void)
{
	clear_dma_ff(FLOPPY_DMA);
}

int MKNAME(fd_set_dma_mode)(char mode)
{
	/* return */ set_dma_mode(FLOPPY_DMA, mode);
}

void MKNAME(fd_set_dma_addr)(unsigned int addr)
{
	set_dma_addr(FLOPPY_DMA, addr);
}

void MKNAME(fd_set_dma_count)(unsigned int count)
{
	set_dma_count(FLOPPY_DMA, count);
}

int MKNAME(fd_get_dma_residue)(void)
{
	return get_dma_residue(FLOPPY_DMA);
}

void MKNAME(fd_enable_irq)(void)
{
	enable_irq(FLOPPY_IRQ);
}

void MKNAME(fd_disable_irq)(void)
{
	disable_irq(FLOPPY_IRQ);
}

void MKNAME(fd_cacheflush)(unsigned char *addr, unsigned int size)
{
	sys_cacheflush((void *)addr, size, DCACHE);
}


/*
 * Tiny Tyne DMA buffer allocator
 *
 * Untested for a long time and changed again and again ...
 * Sorry, but no hardware to test ...
 */
static unsigned long allocated;

/*
 * Not very sophisticated, but should suffice for now...
 */
unsigned long MKNAME(dma_alloc)(size_t size)
{
	unsigned long ret = allocated;
	allocated += size;
	if (allocated > mips_dma_cache_size)
		ret = -1;
	return ret;
}

void MKNAME(dma_init)(void)
{
	if (mips_machtype != DS_MACHINE_TYPE) /* See above for define */
		return;
	allocated = 0;
	printk ("Deskstation %s DMA (%luk) buffer initialized.\n",
		DS_MACH_STR,
	        mips_dma_cache_size >> 10);
}

/*
 * RTC stuff
 */
unsigned char * MKNAME(rtc_read_data)()
{
	/* NOP CITY */
	return 0;
}

void MKNAME(rtc_write_data)(unsigned char data)
{
	/* NOP CITY */
}

/* KLUDGE */
unsigned long vdma_alloc(unsigned long paddr, unsigned long size)
{
	return 0;
}
